ZIP_ADD(3)

NAME
zip_add , - .Nm zip_replace add file to zip archive or replace file in zip archive

LIBRARY
libzip (-lzip)

SYNOPSIS
#include <zip.h>

int zip_add(struct zip *archive, const char *name); "struct zip_source *source"

int zip_replace(struct zip *archive, int index); "struct zip_source *source"

DESCRIPTION
The function zip_add adds a file to a zip archive, while zip_replace replaces an existing file in a zip archive. The argument archive specifies the zip archive to which the file should be added. name is the file's name in the zip archive (for zip_add ), while index specifies which file should be replaced (for zip_replace ). The data is obtained from the source argument. See the zip_source_* functions cited in SEE ALSO.

RETURN VALUES
Upon successful completion, the index of the new file in the archive is returned. Otherwise, -1 is returned and the error code in archive is set to indicate the error.

EXAMPLES
struct zip_source *s; if ((s=zip_source_buffer(archive, buffer, len)) == NULL ||
    zip_add(archive, name, s) 0) {
    zip_source_free(s);
    printf("error adding file: %s, zip_strerror(archive)); }

ERRORS
zip_add and zip_replace fail if:

    [ZIP_ER_EXISTS]
        There is already a file called name in the archive. (Only applies to zip_add ).

    [ZIP_ER_INVAL]
        source or name are NULL, or index is invalid.

    [ZIP_ER_MEMORY]
        Required memory could not be allocated.

SEE ALSO
libzip(3), zip_source_file(3), zip_source_filep(3), zip_source_function(3), zip_source_zip(3)

AUTHORS
Dieter Baron <dillo@giga.or.at> and Thomas Klausner <tk@giga.or.at>